// *********** crc.cpp ***********
// implementations of class crc::
//
#include "crc.h"
using namespace std;

crc::crc()
{
    initcrc32table();
}

void crc::initcrc32table(void)
{
    unsigned int ar[2];
    ar[0]=0;
    ar[1]=crc32_const::CRC32_POLY;
    for (int i=0;i<=0xFF;i++)
    {
    	unsigned int crc32=i;
	for (int n=1;n<=8;n++)
	{
    	    crc32 = (crc32 >> 1) ^ ar[crc32 & 1];
	}
	crc32table[i] = crc32;
    }
#ifdef STDOUT
    cout<<"CRC32 table inited..."<<endl;
#endif
#ifdef DEBUG
#ifdef STDOUT
    cout<<"DEBUG: The table is:"<<endl;
    for (int i=0;i<=0xFF;i++)
	cout<<crc32table[i]<<" |";
    cout<<endl;
#endif
#endif
}

unsigned int crc::updatecrc32(const unsigned char curbyte, const unsigned int curcrc)
{
    return crc32table[(curcrc ^ curbyte) & 0xFF] ^ (curcrc >> 8);
}

unsigned int crc::calccrc32(void* b, int size)
{
    unsigned int c;
    char* p;
    int i;

    c=crc32_const::CRC32_INIT;
    p=(char*)b;
    for(i=0;i<=size-1;i++)
	c=updatecrc32((unsigned char)p[i], c);
    return c;
}
